#include <bits/stdc++.h>
using namespace std;
int n;
int o,a,b,ab;
int c;
int m[5][10005];
bool tf;
string s;
int main() {
    cin >> n;
    cin >> o >> a >> b >> ab;
    tf=true;
    for(int j=1; j<4; j++) {
        for(int i=1; i<n; i++) {
            m[j][i]=0;
            }
        }
    for(int i=1; i<=n; i++) {
       cin >> s;
       cin >> c;
        if(s=="A") {
            if(c==0) {
                continue;
        }
            if(a>=c) {
                a-=c;
                m[2][i]+=c;
                continue;
            }
            if(c>a) {
                c-=a;
                m[2][i]+=a;
            }

            if(c>0) {
                if(o>=c) {
                    o-=c;
                    m[1][i]+=c;
                    continue;
                }
                else {
                    tf=false;
                    continue;
                }

            }
        }
        if(s=="B") {
        if(c==0) {
            continue;
        }
            if(b>=c) {
                b-=c;
                m[3][i]+=c;
                continue;
            }
            if(c>b) {
                c-=b;
                m[3][i]+=b;
            }

            if(c>0) {
                if(o>=c) {
                    o-=c;
                    m[1][i]+=c;
                    continue;
                }
                else {
                    tf=false;
                    continue;
                }

            }


        }

        if(s=="AB") {
            if(c==0) {
                continue;
            }
            if(c>0) {

                if(a>b) {
                    if(a>=c) {
                        a-=c;
                        m[2][i]+=c;
                        continue;
                    }
                    if(c>a) {
                        c-=a;
                        m[2][i]+=a;
                    }
                    if(c>0) {
                        if(b>=c) {
                            b-=c;
                            m[3][i]+=c;
                            continue;
                        }
                        if(c>b) {
                            c-=b;
                            m[3][i]+=b;
                        }
                    }
                }
                if(b>a) {
                    if(b>=c) {
                        b-=c;
                        m[3][i]+=c;
                        continue;
                    }
                    if(c>b) {
                        c-=b;
                        m[3][i]+=b;
                    }
                    if(c>0) {
                        if(a>=c) {
                            a-=c;
                            m[2][i]+=c;
                            continue;
                        }
                        if(c>a) {
                            c-=a;
                            m[2][i]+=a;
                        }
                    }
                }
                if(a==b) {
                    if(b>=c) {
                        b-=c;
                        m[3][i]+=c;
                        continue;
                    }
                    if(c>b) {
                        c-=b;
                        m[3][i]+=b;
                    }
                    if(c>0) {
                        if(a>=c) {
                            a-=c;
                            m[2][i]+=c;
                            continue;
                        }
                        if(c>a) {
                            c-=a;
                            m[2][i]+=a;
                        }
                    }
                }
                if(ab>=c) {
                    ab-=c;
                    m[4][i]+=c;
                    continue;
                }
                if(c>ab) {
                    c-=ab;
                    m[4][i]+=ab;
                }
                if(o>=c) {
                    o-=c;
                    m[1][i]+=c;
                    continue;
                }
                else {
                    tf=false;
                    continue;
                }

            }
        }
        if(s=="O") {
            if(c==0) {
                continue;
            }
            if(o>=c) {
                o-=c;
                m[1][i]+=c;
                continue;
            }
            else {
                tf=false;
                continue;
            }
        }

    }
    if(tf==true) {
        cout << "moguce" << endl;
        for(int i=1; i<=n; i++) {
            for(int j=1; j<=4; j++) {
                cout << m[j][i] << " ";
            }
            cout << endl;
        }

    }
    if(tf==false) {
        cout << "nemoguce" << endl;

    }

    return 0;
}